﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.DotNet.InternalAbstractions;
using System.IO;
using Syncfusion.DocIO.DLS;
using Syncfusion.DocIO;
using System.Net.Http;
using System.Net.Http.Headers;
using Newtonsoft.Json;
using Microsoft.AspNetCore.Hosting;

namespace WordToPDF_Preview2.Controllers
{
    public class HomeController : Controller
    {
        // GET: /<controller>/
        private readonly IHostingEnvironment _hostingEnvironment;
        public HomeController(IHostingEnvironment hostingEnvironment)
        {
            _hostingEnvironment = hostingEnvironment;
        }
        public IActionResult WordToPDF()
        {
            return View();
        }
        [HttpPost]
        public async Task<IActionResult> WordToPDF(ICollection<IFormFile> files)
        {
            if (files.Count == 0)
            {
                return View("WordToPDF");
            }
            foreach (var file in files)
            {
                if (file.FileName.EndsWith(".doc") || file.FileName.EndsWith(".docx"))
                {
                    string basePath = _hostingEnvironment.WebRootPath + @"\DocIO\" + System.IO.Path.GetFileName(file.FileName);
                    MemoryStream inStream = new MemoryStream();
                    await file.CopyToAsync(inStream);
                    //Create client from service
                    ServiceReference1.Service1Client client = new ServiceReference1.Service1Client();
                    //Get the ouput data in bas64 format
                    string outputData = client.GeneratePdfAsync(Convert.ToBase64String(inStream.ToArray())).Result;
                    MemoryStream outStream = new MemoryStream(Convert.FromBase64String(outputData));
                    outStream.Position = 0;
                    return File(outStream, "application/pdf", "WordToPDF.pdf");
                }
            }
            return View("WordToPDF");
        }
        public IActionResult Index()
        {
            return View();
        }

        public IActionResult About()
        {
            ViewData["Message"] = "Your application description page.";

            return View();
        }

        public IActionResult Contact()
        {
            ViewData["Message"] = "Your contact page.";

            return View();
        }

        public IActionResult Error()
        {
            return View();
        }
    }
}
